import { HTMLAttributes } from 'react';
export declare type ComponentLabelProps = {
    /** Id of the component. Will show nothing if id is missing, and will show text only when id is not a valid bit-id */
    bitId?: string;
    /** Explicitly set component version, and override any id that is part of the bit id. */
    versionOverride?: string;
    /** Show full scope name, including owner */
    fullScopeName?: boolean;
    /** base url for links. leave undefined for relative links */
    baseUrl?: string;
} & HTMLAttributes<HTMLDivElement>;
/**
 * Given a component id, shows a label for it and its scope, with a link to its bit.dev entry.
 * @name ComponentLabel
 * @example
 * <ComponentLabel bitId="kutorg.nerv/atoms/lcl" versionOverride="1.5.3" />
 */
export declare function ComponentLabel(props: ComponentLabelProps): JSX.Element;
export declare namespace ComponentLabel {
    var defaultProps: {
        fullScopeName: boolean;
    };
}
