"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DuoComponentBubble = void 0;
const react_1 = __importDefault(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const base_ui_surfaces_card_1 = require("@teambit/base-ui.surfaces.card");
const scope_colors_module_scss_1 = __importDefault(require("./scope-colors.module.scss"));
const duo_component_bubble_module_scss_1 = __importDefault(require("./duo-component-bubble.module.scss"));
const VERSION_QUERY_PARAM = 'version';
const LATEST_VERSION = 'latest';
function DuoComponentBubble(_a) {
    var { bitId, fullScopeName, className, baseUrl } = _a, rest = __rest(_a, ["bitId", "fullScopeName", "className", "baseUrl"]);
    const scopeFullName = bitId.scope;
    return (react_1.default.createElement(base_ui_surfaces_card_1.Card, Object.assign({}, rest, { className: (0, classnames_1.default)(className, scope_colors_module_scss_1.default.scopeColorDefinition, duo_component_bubble_module_scss_1.default.duoComponentBubble), "data-current-scope": scopeFullName, "data-ignore-component-highlight": true }),
        react_1.default.createElement(ScopeBubble, { bitId: bitId, fullScopeName: fullScopeName, className: duo_component_bubble_module_scss_1.default.scopeBubble, baseUrl: baseUrl }),
        react_1.default.createElement(ComponentBubble, { bitId: bitId, baseUrl: baseUrl })));
}
exports.DuoComponentBubble = DuoComponentBubble;
function ScopeBubble(_a) {
    var { bitId, fullScopeName, className, baseUrl = '' } = _a, rest = __rest(_a, ["bitId", "fullScopeName", "className", "baseUrl"]);
    const fullName = bitId.scope;
    const name = bitId.scope;
    const scopeUrl = `${baseUrl}/${bitId.scope.replace('.', '/')}`;
    return (react_1.default.createElement("a", Object.assign({ href: scopeUrl, className: (0, classnames_1.default)(duo_component_bubble_module_scss_1.default.link, className), rel: "noopener noreferrer", target: "_blank" }, rest),
        react_1.default.createElement("div", { className: (0, classnames_1.default)(duo_component_bubble_module_scss_1.default.scopeName) }, fullScopeName ? fullName : name)));
}
function ComponentBubble(_a) {
    var { bitId, className, baseUrl = '' } = _a, rest = __rest(_a, ["bitId", "className", "baseUrl"]);
    const version = bitId.version !== LATEST_VERSION && bitId.version;
    const fullName = bitId.fullName;
    const componentQuery = version && `?${VERSION_QUERY_PARAM}=${version}`;
    const scopeUrl = `${bitId.scope.replace('.', '/')}`;
    const componentUrl = fullName;
    const url = `${baseUrl}/${scopeUrl}/${componentUrl}${componentQuery}`;
    return (react_1.default.createElement("a", { href: url, className: (0, classnames_1.default)(duo_component_bubble_module_scss_1.default.link, duo_component_bubble_module_scss_1.default.componentName, className), rel: "noopener noreferrer", target: "_blank" },
        react_1.default.createElement("div", { className: duo_component_bubble_module_scss_1.default.fullName }, fullName),
        version && (react_1.default.createElement("div", { className: duo_component_bubble_module_scss_1.default.version },
            react_1.default.createElement("span", { className: duo_component_bubble_module_scss_1.default.versionPrefix }, "@"),
            version))));
}
//# sourceMappingURL=duo-component-bubble.js.map