"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OverlayBorder = void 0;
const react_1 = __importStar(require("react"));
const classnames_1 = __importDefault(require("classnames"));
//@ts-ignore
const react_create_ref_1 = __importDefault(require("react-create-ref"));
const core_1 = require("@popperjs/core");
const overlay_border_module_scss_1 = __importDefault(require("./overlay-border.module.scss"));
const base_ui_utils_popper_js_ignore_popper_size_1 = require("@teambit/base-ui.utils.popper-js.ignore-popper-size");
const base_ui_utils_popper_js_resize_to_match_reference_1 = require("@teambit/base-ui.utils.popper-js.resize-to-match-reference");
const BASE_OFFSET = +overlay_border_module_scss_1.default.offset;
/**
 * Highlight a component using a border.<br/>
 * The border is positioned at the top left of the component using [Popper.js](https://popper.js.org/),
 * and covers the element from edge to edge. The border does not interfere with normal user flow,
 * using `pointer-events: none; user-select: none;`.
 *
 * @name OverlayBorder
 * @example
 * this.elementRef = react.createRef();
 * //...
 * <OverlayBorder targetElement={this.elementRef.current} />
 */
class OverlayBorder extends react_1.Component {
    constructor() {
        super(...arguments);
        this.ref = (0, react_create_ref_1.default)();
        this.reposition = (targetElement) => {
            if (!targetElement) {
                this.destroy();
                return;
            }
            const overlayElem = this.ref.current;
            if (!overlayElem)
                return;
            this.popperInstance = (0, core_1.createPopper)(targetElement, overlayElem, {
                placement: 'top-start',
                modifiers: popperModifiers,
            });
            window.requestAnimationFrame(this.step);
        };
        this.step = () => {
            if (!this.popperInstance || !this.props.motionTracking)
                return;
            this.popperInstance.update();
            window.requestAnimationFrame(this.step);
        };
    }
    componentDidMount() {
        const { targetElement } = this.props;
        if (targetElement) {
            this.reposition(targetElement);
        }
    }
    componentWillUnmount() {
        this.destroy();
    }
    componentDidUpdate(prevProps) {
        const nextProps = this.props;
        if (prevProps.targetElement !== nextProps.targetElement) {
            this.reposition(nextProps.targetElement);
        }
    }
    destroy() {
        if (!this.popperInstance)
            return;
        this.popperInstance.destroy();
        this.popperInstance = undefined;
    }
    render() {
        const _a = this.props, { className, targetElement, motionTracking } = _a, rest = __rest(_a, ["className", "targetElement", "motionTracking"]);
        return (react_1.default.createElement("div", Object.assign({}, rest, { className: (0, classnames_1.default)(className, overlay_border_module_scss_1.default.overlayBorder), ref: this.ref })));
    }
}
exports.OverlayBorder = OverlayBorder;
const popperModifiers = [
    base_ui_utils_popper_js_ignore_popper_size_1.ignorePopperSize,
    base_ui_utils_popper_js_resize_to_match_reference_1.resizeToMatchReference,
    {
        name: 'flip',
        enabled: false,
    },
    {
        name: 'offset',
        options: {
            // move box from above the target ('top-start')
            // to directly cover the target.
            offset: ({ reference }) => [BASE_OFFSET, BASE_OFFSET - reference.height],
        },
    },
];
//# sourceMappingURL=overlay-border.js.map